{
  This file was automatically generated on 2012-09-28.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickIMU;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_IMU_FUNCTION_GET_ACCELERATION = 1;
  BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD = 2;
  BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY = 3;
  BRICK_IMU_FUNCTION_GET_ALL_DATA = 4;
  BRICK_IMU_FUNCTION_GET_ORIENTATION = 5;
  BRICK_IMU_FUNCTION_GET_QUATERNION = 6;
  BRICK_IMU_FUNCTION_GET_IMU_TEMPERATURE = 7;
  BRICK_IMU_FUNCTION_LEDS_ON = 8;
  BRICK_IMU_FUNCTION_LEDS_OFF = 9;
  BRICK_IMU_FUNCTION_ARE_LEDS_ON = 10;
  BRICK_IMU_FUNCTION_SET_ACCELERATION_RANGE = 11;
  BRICK_IMU_FUNCTION_GET_ACCELERATION_RANGE = 12;
  BRICK_IMU_FUNCTION_SET_MAGNETOMETER_RANGE = 13;
  BRICK_IMU_FUNCTION_GET_MAGNETOMETER_RANGE = 14;
  BRICK_IMU_FUNCTION_SET_CONVERGENCE_SPEED = 15;
  BRICK_IMU_FUNCTION_GET_CONVERGENCE_SPEED = 16;
  BRICK_IMU_FUNCTION_SET_CALIBRATION = 17;
  BRICK_IMU_FUNCTION_GET_CALIBRATION = 18;
  BRICK_IMU_FUNCTION_SET_ACCELERATION_PERIOD = 19;
  BRICK_IMU_FUNCTION_GET_ACCELERATION_PERIOD = 20;
  BRICK_IMU_FUNCTION_SET_MAGNETIC_FIELD_PERIOD = 21;
  BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD_PERIOD = 22;
  BRICK_IMU_FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = 23;
  BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = 24;
  BRICK_IMU_FUNCTION_SET_ALL_DATA_PERIOD = 25;
  BRICK_IMU_FUNCTION_GET_ALL_DATA_PERIOD = 26;
  BRICK_IMU_FUNCTION_SET_ORIENTATION_PERIOD = 27;
  BRICK_IMU_FUNCTION_GET_ORIENTATION_PERIOD = 28;
  BRICK_IMU_FUNCTION_SET_QUATERNION_PERIOD = 29;
  BRICK_IMU_FUNCTION_GET_QUATERNION_PERIOD = 30;
  BRICK_IMU_FUNCTION_RESET = 243;
  BRICK_IMU_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICK_IMU_CALLBACK_ACCELERATION = 31;
  BRICK_IMU_CALLBACK_MAGNETIC_FIELD = 32;
  BRICK_IMU_CALLBACK_ANGULAR_VELOCITY = 33;
  BRICK_IMU_CALLBACK_ALL_DATA = 34;
  BRICK_IMU_CALLBACK_ORIENTATION = 35;
  BRICK_IMU_CALLBACK_QUATERNION = 36;

type
  TArray0To9OfInt16 = array [0..9] of smallint;

  TBrickIMUNotifyAcceleration = procedure(const x: smallint; const y: smallint; const z: smallint) of object;
  TBrickIMUNotifyMagneticField = procedure(const x: smallint; const y: smallint; const z: smallint) of object;
  TBrickIMUNotifyAngularVelocity = procedure(const x: smallint; const y: smallint; const z: smallint) of object;
  TBrickIMUNotifyAllData = procedure(const accX: smallint; const accY: smallint; const accZ: smallint; const magX: smallint; const magY: smallint; const magZ: smallint; const angX: smallint; const angY: smallint; const angZ: smallint; const temperature: smallint) of object;
  TBrickIMUNotifyOrientation = procedure(const roll: smallint; const pitch: smallint; const yaw: smallint) of object;
  TBrickIMUNotifyQuaternion = procedure(const x: single; const y: single; const z: single; const w: single) of object;

  /// <summary>
  ///  Device for sensing acceleration, magnetic field and angular velocity
  /// </summary>
  TBrickIMU = class(TDevice)
  private
    accelerationCallback: TBrickIMUNotifyAcceleration;
    magneticFieldCallback: TBrickIMUNotifyMagneticField;
    angularVelocityCallback: TBrickIMUNotifyAngularVelocity;
    allDataCallback: TBrickIMUNotifyAllData;
    orientationCallback: TBrickIMUNotifyOrientation;
    quaternionCallback: TBrickIMUNotifyQuaternion;
  protected
    procedure CallbackWrapperAcceleration(const packet: TByteArray); virtual;
    procedure CallbackWrapperMagneticField(const packet: TByteArray); virtual;
    procedure CallbackWrapperAngularVelocity(const packet: TByteArray); virtual;
    procedure CallbackWrapperAllData(const packet: TByteArray); virtual;
    procedure CallbackWrapperOrientation(const packet: TByteArray); virtual;
    procedure CallbackWrapperQuaternion(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid_: string);

    /// <summary>
    ///  Returns the calibrated acceleration from the accelerometer for the 
    ///  x, y and z axis in mG (G/1000, 1G = 9.80605m/s²).
    ///  
    ///  If you want to get the acceleration periodically, it is recommended 
    ///  to use the callback <see cref="BrickIMU.TBrickIMU.Acceleration"/> and set the period with 
    ///  <see cref="BrickIMU.TBrickIMU.SetAccelerationPeriod"/>.
    /// </summary>
    procedure GetAcceleration(out x: smallint; out y: smallint; out z: smallint); virtual;

    /// <summary>
    ///  Returns the calibrated magnetic field from the magnetometer for the 
    ///  x, y and z axis in mG (Milligauss or Nanotesla).
    ///  
    ///  If you want to get the magnetic field periodically, it is recommended 
    ///  to use the callback <see cref="BrickIMU.TBrickIMU.MagneticField"/> and set the period with 
    ///  <see cref="BrickIMU.TBrickIMU.SetMagneticFieldPeriod"/>.
    /// </summary>
    procedure GetMagneticField(out x: smallint; out y: smallint; out z: smallint); virtual;

    /// <summary>
    ///  Returns the calibrated angular velocity from the gyroscope for the 
    ///  x, y and z axis in °/17.5s (you have to divide by 17.5 to
    ///  get the value in °/s).
    ///  
    ///  If you want to get the angular velocity periodically, it is recommended 
    ///  to use the callback <see cref="BrickIMU.TBrickIMU.AngularVelocity"/> and set the period with 
    ///  <see cref="BrickIMU.TBrickIMU.SetAngularVelocityPeriod"/>.
    /// </summary>
    procedure GetAngularVelocity(out x: smallint; out y: smallint; out z: smallint); virtual;

    /// <summary>
    ///  Returns the data from <see cref="BrickIMU.TBrickIMU.GetAcceleration"/>, <see cref="BrickIMU.TBrickIMU.GetMagneticField"/> 
    ///  and <see cref="BrickIMU.TBrickIMU.GetAngularVelocity"/> as well as the temperature of the IMU Brick.
    ///  
    ///  The temperature is given in °C/100.
    ///  
    ///  If you want to get the data periodically, it is recommended 
    ///  to use the callback <see cref="BrickIMU.TBrickIMU.AllData"/> and set the period with 
    ///  <see cref="BrickIMU.TBrickIMU.SetAllDataPeriod"/>.
    /// </summary>
    procedure GetAllData(out accX: smallint; out accY: smallint; out accZ: smallint; out magX: smallint; out magY: smallint; out magZ: smallint; out angX: smallint; out angY: smallint; out angZ: smallint; out temperature: smallint); virtual;

    /// <summary>
    ///  Returns the current orientation (roll, pitch, yaw) of the IMU Brick as Euler
    ///  angles in one-hundredth degree. Note that Euler angles always experience a
    ///  `gimbal lock &lt;http://en.wikipedia.org/wiki/Gimbal_lock&gt;`__.
    ///  
    ///  We recommend that you use quaternions instead.
    ///  
    ///  The order to sequence in which the orientation values should be applied is 
    ///  roll, yaw, pitch. 
    ///  
    ///  If you want to get the orientation periodically, it is recommended 
    ///  to use the callback <see cref="BrickIMU.TBrickIMU.Orientation"/> and set the period with 
    ///  <see cref="BrickIMU.TBrickIMU.SetOrientationPeriod"/>.
    /// </summary>
    procedure GetOrientation(out roll: smallint; out pitch: smallint; out yaw: smallint); virtual;

    /// <summary>
    ///  Returns the current orientation (x, y, z, w) of the IMU as 
    ///  `quaternions &lt;http://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation&gt;`__.
    ///  
    ///  You can go from quaternions to Euler angles with the following formula::
    ///  
    ///   roll  = atan2(2*y*w - 2*x*z, 1 - 2*y*y - 2*z*z)
    ///   pitch = atan2(2*x*w - 2*y*z, 1 - 2*x*x - 2*z*z)
    ///   yaw   =  asin(2*x*y + 2*z*w)
    ///  
    ///  This process is not reversible, because of the 
    ///  `gimbal lock &lt;http://en.wikipedia.org/wiki/Gimbal_lock&gt;`__.
    ///  
    ///  Converting the quaternions to an OpenGL transformation matrix is
    ///  possible with the following formula::
    ///  
    ///   matrix = [[1 - 2*(y*y + z*z),     2*(x*y - w*z),     2*(x*z + w*y), 0],
    ///             [    2*(x*y + w*z), 1 - 2*(x*x + z*z),     2*(y*z - w*x), 0],
    ///             [    2*(x*z - w*y),     2*(y*z + w*x), 1 - 2*(x*x + y*y), 0],
    ///             [                0,                 0,                 0, 1]]
    ///  
    ///  If you want to get the quaternions periodically, it is recommended 
    ///  to use the callback <see cref="BrickIMU.TBrickIMU.Quaternion"/> and set the period with 
    ///  <see cref="BrickIMU.TBrickIMU.SetQuaternionPeriod"/>.
    /// </summary>
    procedure GetQuaternion(out x: single; out y: single; out z: single; out w: single); virtual;

    /// <summary>
    ///  Returns the temperature of the IMU Brick. The temperature is given in 
    ///  °C/100.
    /// </summary>
    function GetIMUTemperature: smallint; virtual;

    /// <summary>
    ///  Turns the orientation and direction LEDs of the IMU Brick on.
    /// </summary>
    procedure LedsOn; virtual;

    /// <summary>
    ///  Turns the orientation and direction LEDs of the IMU Brick off.
    /// </summary>
    procedure LedsOff; virtual;

    /// <summary>
    ///  Returns *true* if the orientation and direction LEDs of the IMU Brick
    ///  are on, *false* otherwise.
    /// </summary>
    function AreLedsOn: boolean; virtual;

    /// <summary>
    ///  Not implemented yet.
    /// </summary>
    procedure SetAccelerationRange(const range: byte); virtual;

    /// <summary>
    ///  Not implemented yet.
    /// </summary>
    function GetAccelerationRange: byte; virtual;

    /// <summary>
    ///  Not implemented yet.
    /// </summary>
    procedure SetMagnetometerRange(const range: byte); virtual;

    /// <summary>
    ///  Not implemented yet.
    /// </summary>
    function GetMagnetometerRange: byte; virtual;

    /// <summary>
    ///  Sets the convergence speed of the IMU Brick in °/s. The convergence speed 
    ///  determines how the different sensor measurements are fused.
    ///  
    ///  If the orientation of the IMU Brick is off by 10° and the convergence speed is 
    ///  set to 20°/s, it will take 0.5s until the orientation is corrected. However,
    ///  if the correct orientation is reached and the convergence speed is too high,
    ///  the orientation will fluctuate with the fluctuations of the accelerometer and
    ///  the magnetometer.
    ///  
    ///  If you set the convergence speed to 0, practically only the gyroscope is used
    ///  to calculate the orientation. This gives very smooth movements, but errors of the
    ///  gyroscope will not be corrected. If you set the convergence speed to something
    ///  above 500, practically only the magnetometer and the accelerometer are used to
    ///  calculate the orientation. In this case the movements are abrupt and the values
    ///  will fluctuate, but there won't be any errors that accumulate over time.
    ///  
    ///  In an application with high angular velocities, we recommend a high convergence
    ///  speed, so the errors of the gyroscope can be corrected fast. In applications with
    ///  only slow movements we recommend a low convergence speed. You can change the
    ///  convergence speed on the fly. So it is possible (and recommended) to increase 
    ///  the convergence speed before an abrupt movement and decrease it afterwards 
    ///  again.
    ///  
    ///  You might want to play around with the convergence speed in the Brick Viewer to
    ///  get a feeling for a good value for your application.
    ///  
    ///  The default value is 30.
    /// </summary>
    procedure SetConvergenceSpeed(const speed: word); virtual;

    /// <summary>
    ///  Returns the convergence speed as set by <see cref="BrickIMU.TBrickIMU.SetConvergenceSpeed"/>.
    /// </summary>
    function GetConvergenceSpeed: word; virtual;

    /// <summary>
    ///  There are several different types that can be calibrated:
    ///  
    ///  <code>
    ///   "Type", "Description",        "Values"
    ///  
    ///   "0",    "Accelerometer Gain", "[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]"
    ///   "1",    "Accelerometer Bias", "[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]"
    ///   "2",    "Magnetometer Gain",  "[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]"
    ///   "3",    "Magnetometer Bias",  "[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]"
    ///   "4",    "Gyroscope Gain",     "[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]"
    ///   "5",    "Gyroscope Bias",     "[bias xl, bias yl, bias zl, temp l, bias xh, bias yh, bias zh, temp h, 0, 0]"
    ///  </code>
    ///  
    ///  The calibration via gain and bias is done with the following formula::
    ///  
    ///   new_value = (bias + orig_value) * gain_mul / gain_div
    ///  
    ///  If you really want to write your own calibration software, please keep
    ///  in mind that you first have to undo the old calibration (set bias to 0 and
    ///  gain to 1/1) and that you have to average over several thousand values
    ///  to obtain a usable result in the end.
    ///  
    ///  The gyroscope bias is highly dependent on the temperature, so you have to
    ///  calibrate the bias two times with different temperatures. The values xl, yl, zl 
    ///  and temp l are the bias for x, y, z and the corresponding temperature for a 
    ///  low temperature. The values xh, yh, zh and temp h are the same for a high 
    ///  temperatures. The temperature difference should be at least 5°C. If you have 
    ///  a temperature where the IMU Brick is mostly used, you should use this 
    ///  temperature for one of the sampling points.
    ///  
    ///  <note>
    ///   We highly recommend that you use the Brick Viewer to calibrate your
    ///   IMU Brick.
    ///  </note>
    /// </summary>
    procedure SetCalibration(const typ: byte; const data: TArray0To9OfInt16); virtual;

    /// <summary>
    ///  Returns the calibration for a given type as set by <see cref="BrickIMU.TBrickIMU.SetCalibration"/>.
    /// </summary>
    function GetCalibration(const typ: byte): TArray0To9OfInt16; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickIMU.TBrickIMU.Acceleration"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  The default value is 0.
    /// </summary>
    procedure SetAccelerationPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickIMU.TBrickIMU.SetAccelerationPeriod"/>.
    /// </summary>
    function GetAccelerationPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickIMU.TBrickIMU.MagneticField"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    /// </summary>
    procedure SetMagneticFieldPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickIMU.TBrickIMU.SetMagneticFieldPeriod"/>.
    /// </summary>
    function GetMagneticFieldPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickIMU.TBrickIMU.AngularVelocity"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    /// </summary>
    procedure SetAngularVelocityPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickIMU.TBrickIMU.SetAngularVelocityPeriod"/>.
    /// </summary>
    function GetAngularVelocityPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickIMU.TBrickIMU.AllData"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    /// </summary>
    procedure SetAllDataPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickIMU.TBrickIMU.SetAllDataPeriod"/>.
    /// </summary>
    function GetAllDataPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickIMU.TBrickIMU.Orientation"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    /// </summary>
    procedure SetOrientationPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickIMU.TBrickIMU.SetOrientationPeriod"/>.
    /// </summary>
    function GetOrientationPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickIMU.TBrickIMU.Quaternion"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    /// </summary>
    procedure SetQuaternionPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickIMU.TBrickIMU.SetQuaternionPeriod"/>.
    /// </summary>
    function GetQuaternionPeriod: longword; virtual;

    /// <summary>
    ///  Calling this function will reset the Brick. Calling this function
    ///  on a Brick inside of a stack will reset the whole stack.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Returns the temperature in °C/10 as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has an
    ///  accuracy of +-15%. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickIMU.TBrickIMU.SetAccelerationPeriod"/>. The parameters are the acceleration
    ///  for the x, y and z axis.
    /// </summary>
    property OnAcceleration: TBrickIMUNotifyAcceleration read accelerationCallback write accelerationCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickIMU.TBrickIMU.SetMagneticFieldPeriod"/>. The parameters are the magnetic field
    ///  for the x, y and z axis.
    /// </summary>
    property OnMagneticField: TBrickIMUNotifyMagneticField read magneticFieldCallback write magneticFieldCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickIMU.TBrickIMU.SetAngularVelocityPeriod"/>. The parameters are the angular velocity
    ///  for the x, y and z axis.
    /// </summary>
    property OnAngularVelocity: TBrickIMUNotifyAngularVelocity read angularVelocityCallback write angularVelocityCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickIMU.TBrickIMU.SetAllDataPeriod"/>. The parameters are the acceleration,
    ///  the magnetic field and the angular velocity for the x, y and z axis as
    ///  well as the temperature of the IMU Brick.
    /// </summary>
    property OnAllData: TBrickIMUNotifyAllData read allDataCallback write allDataCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickIMU.TBrickIMU.SetOrientationPeriod"/>. The parameters are the orientation
    ///  (roll, pitch and yaw) of the IMU Brick in Euler angles. See
    ///  <see cref="BrickIMU.TBrickIMU.GetOrientation"/> for details.
    /// </summary>
    property OnOrientation: TBrickIMUNotifyOrientation read orientationCallback write orientationCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickIMU.TBrickIMU.SetQuaternionPeriod"/>. The parameters are the orientation
    ///  (x, y, z, w) of the IMU Brick in quaternions. See <see cref="BrickIMU.TBrickIMU.GetQuaternion"/>
    ///  for details.
    /// </summary>
    property OnQuaternion: TBrickIMUNotifyQuaternion read quaternionCallback write quaternionCallback;
  end;

implementation

constructor TBrickIMU.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'IMU Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 1;
  callbackWrappers[BRICK_IMU_CALLBACK_ACCELERATION] := {$ifdef FPC}@{$endif}CallbackWrapperAcceleration;
  callbackWrappers[BRICK_IMU_CALLBACK_MAGNETIC_FIELD] := {$ifdef FPC}@{$endif}CallbackWrapperMagneticField;
  callbackWrappers[BRICK_IMU_CALLBACK_ANGULAR_VELOCITY] := {$ifdef FPC}@{$endif}CallbackWrapperAngularVelocity;
  callbackWrappers[BRICK_IMU_CALLBACK_ALL_DATA] := {$ifdef FPC}@{$endif}CallbackWrapperAllData;
  callbackWrappers[BRICK_IMU_CALLBACK_ORIENTATION] := {$ifdef FPC}@{$endif}CallbackWrapperOrientation;
  callbackWrappers[BRICK_IMU_CALLBACK_QUATERNION] := {$ifdef FPC}@{$endif}CallbackWrapperQuaternion;
end;

procedure TBrickIMU.GetAcceleration(out x: smallint; out y: smallint; out z: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ACCELERATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ACCELERATION, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
  z := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetMagneticField(out x: smallint; out y: smallint; out z: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
  z := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetAngularVelocity(out x: smallint; out y: smallint; out z: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
  z := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetAllData(out accX: smallint; out accY: smallint; out accZ: smallint; out magX: smallint; out magY: smallint; out magZ: smallint; out angX: smallint; out angY: smallint; out angZ: smallint; out temperature: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ALL_DATA, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ALL_DATA, response);
  accX := LEConvertInt16From(4, response);
  accY := LEConvertInt16From(6, response);
  accZ := LEConvertInt16From(8, response);
  magX := LEConvertInt16From(10, response);
  magY := LEConvertInt16From(12, response);
  magZ := LEConvertInt16From(14, response);
  angX := LEConvertInt16From(16, response);
  angY := LEConvertInt16From(18, response);
  angZ := LEConvertInt16From(20, response);
  temperature := LEConvertInt16From(22, response);
end;

procedure TBrickIMU.GetOrientation(out roll: smallint; out pitch: smallint; out yaw: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ORIENTATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ORIENTATION, response);
  roll := LEConvertInt16From(4, response);
  pitch := LEConvertInt16From(6, response);
  yaw := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetQuaternion(out x: single; out y: single; out z: single; out w: single);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_QUATERNION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_QUATERNION, response);
  x := LEConvertFloatFrom(4, response);
  y := LEConvertFloatFrom(8, response);
  z := LEConvertFloatFrom(12, response);
  w := LEConvertFloatFrom(16, response);
end;

function TBrickIMU.GetIMUTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_IMU_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_IMU_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickIMU.LedsOn;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_LEDS_ON, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickIMU.LedsOff;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_LEDS_OFF, 4);
  SendRequestNoResponse(request);
end;

function TBrickIMU.AreLedsOn: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_ARE_LEDS_ON, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_ARE_LEDS_ON, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickIMU.SetAccelerationRange(const range: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ACCELERATION_RANGE, 5);
  LEConvertUInt8To(range, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAccelerationRange: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ACCELERATION_RANGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ACCELERATION_RANGE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickIMU.SetMagnetometerRange(const range: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_MAGNETOMETER_RANGE, 5);
  LEConvertUInt8To(range, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetMagnetometerRange: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_MAGNETOMETER_RANGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_MAGNETOMETER_RANGE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickIMU.SetConvergenceSpeed(const speed: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_CONVERGENCE_SPEED, 6);
  LEConvertUInt16To(speed, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetConvergenceSpeed: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_CONVERGENCE_SPEED, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_CONVERGENCE_SPEED, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickIMU.SetCalibration(const typ: byte; const data: TArray0To9OfInt16);
var request: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_CALIBRATION, 25);
  LEConvertUInt8To(typ, 4, request);
  for i := 0 to Length(data) - 1 do LEConvertInt16To(data[i], 5 + (i * 2), request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetCalibration(const typ: byte): TArray0To9OfInt16;
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_CALIBRATION, 5);
  LEConvertUInt8To(typ, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_CALIBRATION, response);
  for i := 0 to 9 do result[i] := LEConvertInt16From(4 + (i * 2), response);
end;

procedure TBrickIMU.SetAccelerationPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ACCELERATION_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAccelerationPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ACCELERATION_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ACCELERATION_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetMagneticFieldPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_MAGNETIC_FIELD_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetMagneticFieldPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetAngularVelocityPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAngularVelocityPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetAllDataPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ALL_DATA_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAllDataPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ALL_DATA_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ALL_DATA_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetOrientationPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ORIENTATION_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetOrientationPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ORIENTATION_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ORIENTATION_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetQuaternionPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_QUATERNION_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetQuaternionPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_QUATERNION_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_QUATERNION_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickIMU.CallbackWrapperAcceleration(const packet: TByteArray);
var x: smallint; y: smallint; z: smallint;
begin
  if (Assigned(accelerationCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    z := LEConvertInt16From(8, packet);
    accelerationCallback(x, y, z);
  end;
end;

procedure TBrickIMU.CallbackWrapperMagneticField(const packet: TByteArray);
var x: smallint; y: smallint; z: smallint;
begin
  if (Assigned(magneticFieldCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    z := LEConvertInt16From(8, packet);
    magneticFieldCallback(x, y, z);
  end;
end;

procedure TBrickIMU.CallbackWrapperAngularVelocity(const packet: TByteArray);
var x: smallint; y: smallint; z: smallint;
begin
  if (Assigned(angularVelocityCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    z := LEConvertInt16From(8, packet);
    angularVelocityCallback(x, y, z);
  end;
end;

procedure TBrickIMU.CallbackWrapperAllData(const packet: TByteArray);
var accX: smallint; accY: smallint; accZ: smallint; magX: smallint; magY: smallint; magZ: smallint; angX: smallint; angY: smallint; angZ: smallint; temperature: smallint;
begin
  if (Assigned(allDataCallback)) then begin
    accX := LEConvertInt16From(4, packet);
    accY := LEConvertInt16From(6, packet);
    accZ := LEConvertInt16From(8, packet);
    magX := LEConvertInt16From(10, packet);
    magY := LEConvertInt16From(12, packet);
    magZ := LEConvertInt16From(14, packet);
    angX := LEConvertInt16From(16, packet);
    angY := LEConvertInt16From(18, packet);
    angZ := LEConvertInt16From(20, packet);
    temperature := LEConvertInt16From(22, packet);
    allDataCallback(accX, accY, accZ, magX, magY, magZ, angX, angY, angZ, temperature);
  end;
end;

procedure TBrickIMU.CallbackWrapperOrientation(const packet: TByteArray);
var roll: smallint; pitch: smallint; yaw: smallint;
begin
  if (Assigned(orientationCallback)) then begin
    roll := LEConvertInt16From(4, packet);
    pitch := LEConvertInt16From(6, packet);
    yaw := LEConvertInt16From(8, packet);
    orientationCallback(roll, pitch, yaw);
  end;
end;

procedure TBrickIMU.CallbackWrapperQuaternion(const packet: TByteArray);
var x: single; y: single; z: single; w: single;
begin
  if (Assigned(quaternionCallback)) then begin
    x := LEConvertFloatFrom(4, packet);
    y := LEConvertFloatFrom(8, packet);
    z := LEConvertFloatFrom(12, packet);
    w := LEConvertFloatFrom(16, packet);
    quaternionCallback(x, y, z, w);
  end;
end;

end.
